# Groupes par défaut

Color Recipes Explorer permet de définir un groupe d'utilisateur par défaut dans un navigateur. Cette fonctionnalité
permet aux utilisateurs utilisant ce navigateur d'être automatiquement connectés au système lors du chargement de l'
application. Après la connexion, ces utilisateurs auront les mêmes permissions que le groupe par défaut.

Lorsqu’aucun utilisateur n'est connecté, le navigateur tentera de se connecter au groupe par défaut au chargement de
l'application. Si le navigateur a un jeton de connexion associé et que celui-ci est valide, l'utilisateur du navigateur
sera connecté en tant que le groupe par défaut. Si ces deux critères ne sont pas respectés, la tentative de connexion
échouera.

## Définir un groupe par défaut

Il est possible de définir le groupe par défaut du navigateur dans la liste des groupes (Administration > Groupes). Pour
ce faire, il suffit d'appuyer sur le bouton «Définir par défaut» du groupe désiré et d'entrer un nom unique au
navigateur dans la boite de dialogue qui s'affiche. En appuyant sur le bouton «Continuer», le nom est validé, puis un
jeton de connexion unique est assigné au navigateur.

### Critères de validation

Pour être valide, le nom du navigateur doit être unique.

## Gestion des jetons de connexion

### Connaître le groupe par défaut d'un navigateur

Après la connexion automatique au groupe, le nom du navigateur et le nom du groupe par défaut s'afficheront à la gauche
du logo de l'application, en haut à droite.

Si l'utilisateur s'est connecté manuellement au système (et non pas à un groupe par défaut), il est seulement possible
de
le savoir si cet utilisateur est un administrateur.
Pour ce faire, le groupe par défaut sera affiché dans la liste des groupes d'utilisateurs (Administration > Groupes).
Si un jeton de connexion est présent dans le navigateur, le bouton "Définir par défaut" ne sera pas présent et le
texte "Groupe par défaut" sera affiché à sa place dans la ligne du groupe par défaut du navigateur.

### Voir tous les jetons de connexion

Tous les jetons de connexion enregistrés dans le système sont listés dans une table à: Administration > Ordinateurs.
Seuls les administrateurs peuvent accéder à cette page.

Chaque ligne de la table représente un seul jeton et ces informations sont listées:

* Identifiant: L'UUID (Universal Unique Identifier) du jeton. C'est la seule information stockée dans les navigateurs.
* Nom: Le nom unique du jeton.
* Groupe: Le nom du groupe auquel les utilisateurs utilisant ce jeton seront connectés.
* État: Si le jeton est activé ou désactivé.

De plus, il est possible de désactiver (ou d'activer) ou de supprimer chaque jeton.
Désactiver un jeton permet d'empêcher la connexion temporairement jusqu'à sa réactivation, tandis que la suppression
l'empêche définitivement.

### Suppression d'un jeton de connexion

Supprimer un jeton de connexion permet d'empêcher toutes les connexions l'utilisant définitivement. Les jetons supprimés
ne sont pas affichés dans la liste des jetons.

Dans la liste des jetons de connexion (Administration > Ordinateurs), appuyer sur le bouton «Supprimer» de la ligne du
jeton à supprimer.
Une boite de confirmation s'affichera. Après confirmation, le jeton sera supprimé* du système et ne sera plus utilisable
immédiatement.

### Désactivation d'un jeton de connexion

Désactiver un jeton de connexion permet d'empêcher toutes les connexions l'utilisant temporairement. Les jetons
désactivés sont affichés dans la liste des jetons.

Dans la liste des jetons de connexion (Administration > Ordinateurs), appuyer sur le bouton «Désactiver» de la ligne du
jeton à désactiver. Le jeton sera immédiatement désactivé et ne sera plus utilisable.

\* Le jeton sera toujours stocké dans la base de données, mais sera marqué comme étant supprimé. Cela permet d'assurer
qu'aucun
futur jeton ne soit créé en utilisant un identifiant supprimé, ce qui serait une faille de sécurité. Ces jetons ne sont
pas accessibles depuis l'interface utilisateur.

### Assignation d'un jeton de connexion

Par souci de sécurité, les jetons de connexion peuvent seulement être assignés lors de leur création.
Les jetons existants peuvent seulement être désactivés ou supprimés.
Ainsi, si un des jetons est compromis, il suffit de le supprimer pour empêcher toutes les connexions avec celui-ci,
et seulement un des navigateurs peut être impacté.

## Stockage et format des jetons de connexion

Les jetons de connexion utilisent le format [JWT](https://jwt.io/) signé (JWS). Ce format permet de garantir l'intégrité
du jeton,
c'est-à-dire que l'utilisation d'un jeton créé ou modifié par un tiers parti provoquera l'échec de la connexion.

Ces jetons sont stockés dans les cookies du navigateur, sous le nom ```Group-Token```. Ainsi, ils ne seront pas
supprimés à la fermeture du
navigateur ou de l'ordinateur. 
